/* $Id: TCP_talk_srvr.c,v 1.5 1995/08/24 19:20:23 arnaud Exp arnaud $ */
/* TCP_talk_srvr.c */


/*********************************************************************
 TCP_talk: real-time sound transmission over TCP/IP
    
    Copyright (C) 1995  Arnaud Louet

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


***********************************************************************/


#include "Copyright.h"
#include "debug.h"
#include "talk.h"
#include "sock_utils.h"
#include "DSP_util.h"
#include "misc.h"

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>

#define QLEN 1			/* max len of waiting queue for connection */
				/* requests                                */


int main(int argc, char * argv)
{
  struct sockaddr_in client;
  int client_addrlen;
  char *service = DEFAULT_PORT;
  int msock;			/* master socket: only here to listen */
				/* and accept calls                   */
  int ssock;			/* slave socket                       */

  struct DSP_config sound_param;
  int DSP_filedesc;

  int status;
  int state;
  unsigned long flag_compression;
  
  int send_bufflen = TCP_BUFF_SIZE;
  int rcv_bufflen = TCP_BUFF_SIZE;
  
  extern char buffer[BLOCK_SIZE];

  int send_len;
  
  
  init_sin_tbl();
  msock = passiveTCP(service, QLEN);
 
  disable_input_buffering();

  for ( ; ; )
    {
      client_addrlen = (int)sizeof (struct sockaddr_in);
      if ((ssock=accept( msock, (struct sockaddr *) &client, &client_addrlen)) == -1)
	exerror("accept in main");

      /* set_TCP_bufflen( ssock, &send_bufflen, &rcv_bufflen); */
      
      if ( DSP_ready() )
	{
	  status = STT_READY;
	  blk_write( ssock, &status, sizeof status);
	}
      else
	{
	  status =  STT_DSP_NOT_READY;
	  blk_write( ssock, &status, sizeof status);
	  continue;
	}
      
      blk_read(ssock, &sound_param, sizeof sound_param);
      DSP_filedesc = init_DSP( &sound_param, DSP_READWRITE);
      blk_write( ssock, &sound_param, sizeof sound_param);
      blk_read(ssock, &flag_compression, sizeof flag_compression);
      

      stdin_flush();
      
      
     /* setsockopt(ssock, SOL_SOCKET, SO_SNDLOWAT, &send_len, sizeof (send_len)); */

                                /* main loop */
      for ( ; ; )		/* actualk  sound transmition */
	{
	  fprintf(stderr, "Now receiving\n");
	  while ( (state = receive_block_TCP( ssock, DSP_filedesc, flag_compression)) == SR_CONTINUE )
	    ;
#ifdef DEBUG
	  fprintf(stderr, "receive_bock returned %d\n", state);
#endif
	  if ( state == SR_DISCONNECT )
	    break;
	  flush_DSP(DSP_filedesc);
	  stdin_flush();
	  fprintf(stderr, "Now sending \n");
	  
	  while ( (state = send_block_TCP( ssock, DSP_filedesc, flag_compression) == SR_CONTINUE))
	    ;
#ifdef DEBUG
	  fprintf(stderr, "send_block returned: %d\n",state);
#endif
	  if ( state == SR_DISCONNECT )
	    break;
	  flush_DSP(DSP_filedesc);
	}
    }
}

  














