/* $Id: sock_utils.h,v 1.2 1995/09/21 03:51:32 arnaud Exp arnaud $ */


/* sock_utils.h header of sock_utils, this library */
/*  allows to connect a socket in TCP or UDP mode  */

/* this code is almost identical to what appears in the book 
 *  internetworking with 'TCP/IP vol III', a book that helped me 
 *  get started with the sockets and client/server application design. 
 *  The code was slightly modified to work under Linux. 
 *  Please refer to the book for the original code. 
 * 
 * 
 *  Portions of this software are covered by the following copyright:
 * Copyright (c) 1993, 1994 Douglas E. Comer, David L. Stevens, and
 * Prentice Hall, Inc. All rights reserved.
 * Redistribution and use in source and binary forms are permitted
 * provided that this notice is preserved and that due credit is given
 * to the copyright holders. The names of the copyright holders
 * may not be used to endorse or promote products derived from this
 * software without specific prior written permission. This software
 * is provided ``as is'' without express or implied warranty. The authors
 * assume no liability for damages incidental or consequential, nor is the
 * software warranted for correctness or suitability for any purpose.
 * Portions of this software are documented in the book: 
 * Comer, D. E. and D. L. Stevens [1993], 'Internetworking with TCP/IP Vol 3: 
 * Client-Server Programming and Applications', Prentice-Hall,
 * Englewood Cliffs, New Jersey.
 * This software may not be sold or published in printed form without written
 * permission from the copyright holders. */

int connectTCP(char* host, char* service);
int connectUDP(char* host, char* service);
int connectsock(char* host, char* service, char* protocol);

int passiveUDP( char* service );
int passiveTCP( char* service, int qlen );
int passivesock( char* service, char* protocol, int qlen);

/* --The code from Comer and Stevens stops here---*/
/* -----------------------------------------------*/
/* -- the following code is my own one -----------*/

void set_TCP_bufflen( int sock, int *len_TX, int *len_RX);

void sock_read( int sock_fd, void *buf, unsigned int *count);
void sock_write( int sock_fd, void *buf, unsigned int count);

