/* 
 * drum.h
 * 
 * Module for definition of the main structures as well as 
 * the functions in sbdrum used by xdrum.c
 * 
 * $Date: 1996/01/07 20:20:29 $
 * 
 * $Revision: 1.0 $
 * 
 * 
 */ 

#ifndef _DRUM_H
#define _DRUM_H


#define MAX_DRUMS 120
#define MAX_PATTERNS 255
#define SONG_BUF_LENGTH  400

typedef struct  {
   char *Name;
   char *Filename;
   int Loaded;
   int Filetype;
   int SampleNum;
   int col;                        /* Column in GUI */
   int pan;                        /* Panning of drum */
   int vol;                        /* Volume of drum */
   short *sample;
   int length;
} *pDrum,tDrum;


typedef struct  {
   pDrum Drum;
   int beat[16];
} *pDrumPattern,tDrumPattern;

typedef struct  {
   tDrumPattern DrumPattern[MAX_DRUMS];
} *pPattern,tPattern;
     
extern int MAIN(int argc, char **argv); 
extern void starttimer(void);
extern void PlayPattern(int Patt,int Measure);
extern unsigned long GetUpdateIntervall(int PattI);
extern int StopPlaying(void);
extern int EmptyCard(void);
extern int load_sample (int samplenum,char *name,int pan,int Intel);
#endif

